; SerialPort control
; Originally by wisely from http://www.autohotkey.com/forum/topic26533.html
; Modified to demo general I/O with a Wixel.
#NoEnv ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input ; Recommended for new scripts due to its superior speed and reliability.
#SingleInstance force
OnExit ExitRoutine

SetTimer, Timer, 250
SetTimer, TimerBlink, 500

COM=1
;
RS232_Port     = COM%COM%
RS232_Baud     = 57600
RS232_Parity   = N
RS232_Data     = 8
RS232_Stop     = 1


Gui, Add, Text,     x16 y1, COM
Gui, Add, Text,     x42 y1,
Gui, Add, UpDown,   vCOM Range1-9 right gSetCOM y1,
Gui, Add, Text,     vCOMerror y1 x+10 w99,
Gui, Add, GroupBox, x6 y17 w182 h90 , Inputs
Gui, Add, GroupBox, x6 y127 w182 h90 , Outputs
Gui, Add, CheckBox, x26 y37 w50 h20 , DCD
Gui, Add, CheckBox, x96 y37 w50 h20 , DSR
Gui, Add, CheckBox, Checked0 vBeepDCR x26 y57 w50 h20 , Beep
Gui, Add, CheckBox, Checked0 vBeepDSR x96 y57 w50 h20 , Beep
Gui, Add, CheckBox, Checked0 vInvertDCD x26 y77 w50 h20 , Invert
Gui, Add, CheckBox, Checked0 vInvertDSR x96 y77 w50 h20 , Invert
Gui, Add, CheckBox, Checked0 vRTS gTimer x26  y157 w50 h20 , RTS
Gui, Add, CheckBox, Checked0 vDTR gTimer x96 y157 w50 h20 , DTR
Gui, Add, Checkbox, Checked0 vBlinkRTS gTimer x26 y177 w50 h20, Blink
Gui, Add, Checkbox, Checked0 vBlinkDTR gTimer x96 y177 w50 h20, Blink
;
Gui, Show, x232 y138 h220 w200, Wixel 1


; Intentional fall throught to SetCOM as part of autoexec section

SetCOM:
RS232_Port     = COM%COM%
RS232_Settings = %RS232_Port%:baud=%RS232_Baud% parity=%RS232_Parity% data=%RS232_Data% stop=%RS232_Stop% dtr=Off
RS232_Close(RS232_FileHandle)
RS232_FileHandle:= RS232_Initialize(RS232_Settings)
If (RS232_FileHandle<0)
	GuiControl, , COMerror, Invalid Port
Else
	GuiControl, , COMerror, 
Gosub, Outputs   
return


Timer:
gui Submit,NoHide
; Set output bits
If (DTR=1)
   RS232_EscapeCommFunction(RS232_FileHandle,5) ; DTR=1
Else
   RS232_EscapeCommFunction(RS232_FileHandle,6) ; DTR=0
If (RTS=1)
   RS232_EscapeCommFunction(RS232_FileHandle,3) ; RTS=1
Else
   RS232_EscapeCommFunction(RS232_FileHandle,4) ; RTS=0
;
; Read input bits, check for inverted checkbox
PortStatus:=RS232_GetCommModemStatus(RS232_FileHandle)
;
DCDBit:=((PortStatus & 0x80) > 0)          ; CD=1
DCDBit:=(InvertDCD ? !DCDBit : DCDBit)     ; Invert it?
GuiControl, , DCD, %DCDBit%
If BeepDCR && DCDBit
   SoundBeep, 500, 200
;
DSRBit:=((PortStatus & 0x20) > 0)          ; DSR=1
DSRBit:=(InvertDSR ? !DSRBit : DSRBit)     ; Invert it?
GuiControl, , DSR, %DSRBit%
If BeepDSR && DSRBit
   SoundBeep, 750, 200
Return

TimerBlink:
If (BlinkDTR) 
	GuiControl, , DTR, % !DTR  ; Invert the setting
If (BlinkRTS)
	GuiControl, , RTS, % !RTS
;ToolTip,  RTS %RTS%/%BlinkRTS% DTR %DTR%/%BlinkDTR% 
Return

Outputs:
RS232_EscapeCommFunction(RS232_FileHandle,6) ; DTR=0
RS232_EscapeCommFunction(RS232_FileHandle,4) ; RTS=0
Return

GuiClose:
ExitRoutine:
SetTimer, DieDieDie, 500 ; in case problem in RS232_Close
RS232_Close(RS232_FileHandle)
DieDieDie:
ExitApp


;################### Serial_Port_Console_ReadFile.ahk ###################
; 8/11/09
; Assembled, tested (on WinXP), and debugged by aobrien with help from
;   other AHK forum members (especially Lexikos) and threads.
;
; 21Apr2011 - Modified to use negative return vlaues for errors rather than msgbox, 
;             Added RS232_EscapeCommFunction(RS232_FileHandle, nFunc),
;             Added RS232_GetCommModemStatus(RS232_FileHandle)
;             Both By wisely from http://www.autohotkey.com/forum/topic26533.html
;
; This script is based upon dll structures that are built into the
; Microsoft Windows environment. This script is ugly (not very readable),
; because, it was written for demonstration purposes and I didn't want
; to complicate things by using #Include files.
;
; The most useful subroutines are listed below. Take them and write your
; application around them.
;     RS232_FileHandle:= RS232_Initialize(RS232_Settings) -- Get the filehandle
;     RS232_Close(RS232_FileHandle)
;     RS232_Read(RS232_FileHandle,"0xFF",RS232_Bytes_Received) -- 0xFF Size of receive buffer. This
;                                returns HEX data (in ASCII form) received from the serial port.
;     Example: Read_Data := RS232_Read(RS232_FileHandle,"0xFF",RS232_Bytes_Received) ;if the RX buffer
;              contained 0x11, 0x22, 0x00, 0x33, 0x44 then Read_Data will contain 1122003344
;
;     RS232_Write(RS232_FileHandle,Hex_Data) -- Comma delimited hex data. If I wanted to
;                               send "Hello World" I would do the following:
;     ;ASCII DATA=  H    e    l    l    o   SP    W    o    r    l    d
;     Hex_Data = 0x48,0x65,0x6C,0x6C,0x6F,0x20,0x57,0x6F,0x72,0x6C,0x64
;     RS232_Write(RS232_FileHandle,Hex_Data)
;     RS232_Status:=RS232_GetCommModemStatus(RS232_FileHandle) ; Status
;                   GetCommModemStatus values returned [ToDo doc the TX pin]
;                   080=01010000 DSR/CD internal pullup resister
;                   112=01110000 DSR->Gnd  so if (Status & 0x20) DSR=1
;                   208=11010000 CD->Gnd   so if (Status & 0x80) CD=1
;                   240=11110000 Both->Gnd 
;     RS232_EscapeCommFunction(RS232_FileHandle, nFunc)
;                   nFunc values 
;                   3 Set RTS=1, 
;                   4 Set RTS=0, 
;                   5 Set DTR=1,
;                   6 Set DTR=0,        
;                   8 Set TX =1
;                   9 Set TX =0
; Instructions:
; 1) Copy the RS232 port settings below to your AutoExec section modify to your needs
;########################################################################
;###### User Variables ##################################################
;########################################################################
RS232_Port     = COM1
RS232_Baud     = 19200
RS232_Parity   = N
RS232_Data     = 8
RS232_Stop     = 1
RS232_Settings   = %RS232_Port%:baud=%RS232_Baud% parity=%RS232_Parity% data=%RS232_Data% stop=%RS232_Stop% dtr=Off

;########################################################################
;###### Initialize RS232 COM Subroutine #################################
;########################################################################
RS232_Initialize(RS232_Settings)
{
  ;21Apr2011 changed to return negative result rather than msg for errors & set RS232_Error
  ; BCD error        = -1
  ; FileCreate error = -2
  ; SCS error        = -3
  ; SCT error        = -4
  Global RS232_Error
  ;###### Extract/Format the RS232 COM Port Number ######
  ;7/23/08 Thanks krisky68 for finding/solving the bug in which RS232 COM Ports greater than 9 didn't work.
  StringSplit, RS232_Temp, RS232_Settings, `:
  RS232_Temp1_Len := StrLen(RS232_Temp1)  ;For COM Ports > 9 \\.\ needs to prepended to the COM Port name.
  If (RS232_Temp1_Len > 4)                   ;So the valid names are
    RS232_COM = \\.\%RS232_Temp1%             ; ... COM8  COM9   \\.\COM10  \\.\COM11  \\.\COM12 and so on...
  Else                                          ;
    RS232_COM = %RS232_Temp1%

  ;8/10/09 A BIG Thanks to trenton_xavier for figuring out how to make COM Ports greater than 9 work for USB-Serial Dongles.
  StringTrimLeft, RS232_Settings, RS232_Settings, RS232_Temp1_Len+1 ;Remove the COM number (+1 for the semicolon) for BuildCommDCB.
  ;MsgBox, RS232_COM=%RS232_COM% `nRS232_Settings=%RS232_Settings%

  ;###### Build RS232 COM DCB ######
  ;Creates the structure that contains the RS232 COM Port number, baud rate,...
  VarSetCapacity(DCB, 28)
  BCD_Result := DllCall("BuildCommDCB"
       ,"str" , RS232_Settings ;lpDef
       ,"UInt", &DCB)        ;lpDCB
  If (BCD_Result <> 1)
  {
    RS232_Error:="BCD=" . BCD_Result
    Return -1
  }
  ;###### Create RS232 COM File ######
  ;Creates the RS232 COM Port File Handle
  RS232_FileHandle := DllCall("CreateFile"
       ,"Str" , RS232_COM     ;File Name         
       ,"UInt", 0xC0000000   ;Desired Access
       ,"UInt", 3            ;Safe Mode
       ,"UInt", 0            ;Security Attributes
       ,"UInt", 3            ;Creation Disposition
       ,"UInt", 0            ;Flags And Attributes
       ,"UInt", 0            ;Template File
       ,"Cdecl Int")
  If (RS232_FileHandle < 1)
  {
      RS232_Error:="CF=" . RS232_FileHandle
      Return -2
  }
  ;###### Set COM State ######
  ;Sets the RS232 COM Port number, baud rate,...
  SCS_Result := DllCall("SetCommState"
       ,"UInt", RS232_FileHandle ;File Handle
       ,"UInt", &DCB)          ;Pointer to DCB structure
  If (SCS_Result <> 1)
  {
    RS232_Close(RS232_FileHandle)
    RS232_Error:="SCS=" . SCS_Result
    Return -3
  }
  ;###### Create the SetCommTimeouts Structure ######
  ReadIntervalTimeout        = 0xffffffff
  ReadTotalTimeoutMultiplier = 0x00000000
  ReadTotalTimeoutConstant   = 0x00000000
  WriteTotalTimeoutMultiplier= 0x00000000
  WriteTotalTimeoutConstant  = 0x00000000

  VarSetCapacity(Data, 20, 0) ; 5 * sizeof(DWORD)
  NumPut(ReadIntervalTimeout,         Data,  0, "UInt")
  NumPut(ReadTotalTimeoutMultiplier,  Data,  4, "UInt")
  NumPut(ReadTotalTimeoutConstant,    Data,  8, "UInt")
  NumPut(WriteTotalTimeoutMultiplier, Data, 12, "UInt")
  NumPut(WriteTotalTimeoutConstant,   Data, 16, "UInt")

  ;###### Set the RS232 COM Timeouts ######
  SCT_result := DllCall("SetCommTimeouts"
     ,"UInt", RS232_FileHandle ;File Handle
     ,"UInt", &Data)         ;Pointer to the data structure
  If (SCT_result <> 1)
  {
    RS232_Close(RS232_FileHandle)
    RS232_Error:="SCT=" . SCT_result
    Return -4
    ;Exit
  }
  Return %RS232_FileHandle%
}
;########################################################################
;###### Close RS23 COM Subroutine #######################################
;########################################################################
RS232_Close(RS232_FileHandle)
{
  ;21Apr2011 changed to return negative result rather than msg for errors & set RS232_Error
  ; CH error        = -1
  Global RS232_Error
  ;###### Close the COM File ######
  CH_result := DllCall("CloseHandle", "UInt", RS232_FileHandle)
  If (CH_result <> 1) {
      RS232_Error:="CH=" . CH_result
      Return -1
   }
  Return
}
;########################################################################
;###### Write to RS232 COM Subroutines ##################################
;########################################################################
RS232_Write(RS232_FileHandle,Message)
{
  ;21Apr2011 changed to return negative result rather than msg for errors & set RS232_Error
  ; WF error        = -1
  Global RS232_Error
  
  Data_Length := StrLen(Message)

  ;###### Write the data to the RS232 COM Port ######
  WF_Result := DllCall("WriteFile"
       ,"UInt" , RS232_FileHandle ;File Handle
       ,"UInt" , &Message          ;Pointer to string to send
       ,"UInt" , Data_Length    ;Data Length
       ,"UInt*", Bytes_Sent     ;Returns pointer to num bytes sent
       ,"Int"  , "NULL")
  If (WF_Result <> 1 or Bytes_Sent <> Data_Length) {
      RS232_Error:="WF=" . WF_result
      Return -1
   }
}

;########################################################################
;###### Read from RS232 COM Subroutines #################################
;########################################################################
RS232_Read(RS232_FileHandle,Num_Bytes,ByRef RS232_Bytes_Received)
{
  ;21Apr2011 changed to return negative result rather than msg for errors & set RS232_Error
  ; RF error        = -1
  Global RS232_Error

  SetFormat, Integer, HEX

  ;Set the Data buffer size, prefill with 0x55 = ASCII character "U"
  ;VarSetCapacity won't assign anything less than 3 bytes. Meaning: If you
  ;  tell it you want 1 or 2 byte size variable it will give you 3.
  Data_Length  := VarSetCapacity(Data, Num_Bytes, 0x55)
  ;MsgBox, Data_Length=%Data_Length%

  ;###### Read the data from the RS232 COM Port ######
  ;MsgBox, RS232_FileHandle=%RS232_FileHandle% `nNum_Bytes=%Num_Bytes%
  Read_Result := DllCall("ReadFile"
       ,"UInt" , RS232_FileHandle   ; hFile
       ,"Str"  , Data             ; lpBuffer
       ,"Int"  , Num_Bytes        ; nNumberOfBytesToRead
       ,"UInt*", RS232_Bytes_Received   ; lpNumberOfBytesReceived
       ,"Int"  , 0)               ; lpOverlapped

  ;MsgBox, RS232_FileHandle=%RS232_FileHandle% `nRead_Result=%Read_Result% `nBR=%RS232_Bytes_Received% ,`nData=%Data%
  If (Read_Result <> 1)
  {
    RS232_Close(RS232_FileHandle)
    RS232_Error:=%Read_Result%
    Return -1
  }

  ;###### Format the received data ######
  ;This loop is necessary because AHK doesn't handle NULL (0x00) characters very nicely.
  ;Quote from AHK documentation under DllCall:
  ;     "Any binary zero stored in a variable by a function will hide all data to the right
  ;     of the zero; that is, such data cannot be accessed or changed by most commands and
  ;     functions. However, such data can be manipulated by the address and dereference operators
  ;     (& and *), as well as DllCall itself."
  i = 0
  Data_HEX =
  Loop %RS232_Bytes_Received%
  {
    ;First byte into the Rx FIFO ends up at position 0

    Data_HEX_Temp := NumGet(Data, i, "UChar") ;Convert to HEX byte-by-byte
    StringTrimLeft, Data_HEX_Temp, Data_HEX_Temp, 2 ;Remove the 0x (added by the above line) from the front

    ;If there is only 1 character then add the leading "0'
    Length := StrLen(Data_HEX_Temp)
    If (Length =1)
      Data_HEX_Temp = 0%Data_HEX_Temp%

    i++

    ;Put it all together
    Data_HEX := Data_HEX . Data_HEX_Temp
  }
  ;MsgBox, Read_Result=%Read_Result% `nRS232_Bytes_Received=%RS232_Bytes_Received% ,`nData_HEX=%Data_HEX%

  SetFormat, Integer, DEC
  Data := Data_HEX

  Return Data
}

; Directs a specified communications device to perform a function. Added 21Apr2011
RS232_EscapeCommFunction(RS232_FileHandle, nFunc) {
DllCall("EscapeCommFunction"
            , "Uint",RS232_FileHandle
            , "Uint",nFunc
            ,"Cdecl Int")
Return
}

; Retrieves modem control-register values. Added 21Apr2011
RS232_GetCommModemStatus(RS232_FileHandle) {
VarSetCapacity(lpModemStat, 28)
x := DllCall("GetCommModemStatus"
            , "Uint",RS232_FileHandle           
            , "Int *",lpModemStat
            ,"Cdecl Uint")
Return lpModemStat
}
